from typing import Final, Optional


class ImageRef:
    def __init__(self,
                 ts: Optional[int],
                 url: Optional[str] = None,
                 codec: Optional[str] = None,
                 width: Optional[int] = None,
                 height: Optional[int] = None):

        self.ts: Final[int | None] = ts
        self.url: str | None = url  # TODO: make it final
        self.codec: Final[str | None] = codec
        self.width: Final[int | None] = width
        self.height: Final[int | None] = height

    @property
    def wh(self) -> tuple[int, int] | None:
        if None not in (self.width, self.height):
            return self.width, self.height

        raise NotImplementedError()
