from typing import Dict

from edge.types.dir import Dir


def encode_dir_text(value_code: Dir) -> str:
    code_to_text_map = {
        Dir.CODE_U: 'unknown',
        Dir.CODE_A: 'approaching',
        Dir.CODE_R: 'receding'
    }

    return code_to_text_map[value_code]


def decode__dir_text(value_text: str) -> Dir:
    text_to_code_map: Dict[str, Dir] = {
        'unknown': Dir.CODE_U,
        'approaching': Dir.CODE_A,
        'receding': Dir.CODE_R
    }

    value_code = text_to_code_map.get(value_text)
    if value_code is None:
        raise NotImplementedError()

    return Dir(value_code)
