from typing import Final, Optional

from edge.types.geoposition import Geoposition
from edge.types.location import Location


class Origin:
    def __init__(self,
                 uuid: str,
                 time: str,
                 name: str,
                 location: Location,
                 geolocation: Optional[Geoposition] = None):

        self.uuid: Final[str] = uuid
        self.time: Final[str] = time
        self.name: Final[str] = name

        self.location: Final[Location] = location
        self.geolocation: Final[Geoposition | None] = geolocation
