from typing import Dict, List

from edge.webserver.sysconf import ph


# noinspection PyClassHasNoInit
class RootApi:
    @staticmethod
    def get_units_info(unit_refs: List[str] = None) -> List[Dict]:
        root_info = ph.RootInfoUiconf.get_info()
        if not unit_refs:
            return [root_info]

        units_info = []
        for unit_ref in unit_refs:
            unit_info = ph.InfoUiconf.find_unit_r(root_info, unit_ref)
            if unit_info:
                units_info.append(unit_info)

        return units_info
