from typing import Dict, Tuple

from edge.types.identity import Identity


def create_unit__wiegand___pcb(unit_name: str, wiegand_conf: Dict) -> Tuple[str, Dict]:
    uiref = Identity(unit_name)
    parent_uiref = uiref.parent

    return unit_name, {
        'bundle': ['libunity_wiegand', '1.0.0'],
        'type': parent_uiref.type,
        'name': parent_uiref.ref,
        'units':
        [
            {
                'type': uiref.type,
                'name': uiref.ref,
                'conf': wiegand_conf
            }
        ]
    }


def create_unit__wiegand___udp(unit_name: str, wiegand_conf: Dict) -> Tuple[str, Dict]:
    uiref = Identity(unit_name)
    parent_uiref = uiref.parent

    return unit_name, {
        'bundle': ['libunity_wiegand', '1.0.0'],
        'type': parent_uiref.type,
        'name': parent_uiref.ref,
        'units':
        [
            {
                'type': uiref.type,
                'name': uiref.ref,
                'conf': wiegand_conf
            }
        ]
    }
