from typing import Dict, Union

from edge.webserver.sysconf import ph
from edge.webserver.sysconf.dgmod import dg

UiModToConfMap = Dict[Union[ph.UiMod, ph.UiMod2], Dict]


class BaseCreator:
    def __init__(self):
        pass

    @property
    def dgmod(self) -> dg.DgMod:
        raise NotImplementedError

    def prepare(self, uimod_to_conf_map: UiModToConfMap):
        raise NotImplementedError

    def rollback(self) -> None:
        raise NotImplementedError

    def complete(self) -> None:
        raise NotImplementedError

    def notify(self) -> None:
        raise NotImplementedError
