from typing import Final

from edge.webserver.sysconf.dgmod.mg.mg_halt import HaltConfBuilder
from edge.webserver.sysconf.dgmod.mg.mg_main import MainConfBuilder
from edge.webserver.sysconf.dgmod.mg.mg_misc import MiscConfBuilder
from edge.webserver.sysconf.dgmod.mg.uiconf import IUiConfProvider


class FusionUiConfProvider(IUiConfProvider):
    def __init__(self, uimod_id: str) -> None:
        self._uimod_id: Final[str] = uimod_id

    def setup_builders(self,
                       main_builder: MainConfBuilder,
                       misc_builder: MiscConfBuilder,
                       halt_builder: HaltConfBuilder) -> None:

        main_builder.setup_scene_event_args([
            f'mg{main_builder.uimod_id}-tr{self._uimod_id}-scene'
        ], require_mono8=True)
