from typing import Dict, Final

from edge.webserver.sysconf.dgmod.rg.rg_halt import HaltConfBuilder
from edge.webserver.sysconf.dgmod.rg.rg_main import MainConfBuilder
from edge.webserver.sysconf.dgmod.rg.uiconf import IUiConfProvider


class _UiConfProvider(IUiConfProvider):
    def __init__(self, uimod_id: str, uiconf: Dict) -> None:
        self._uimod_id: Final[str] = uimod_id
        self._uiconf: Final[Dict] = uiconf

    def setup_builders(self,
                       main_builder: MainConfBuilder,
                       halt_builder: HaltConfBuilder) -> None:

        pri_jnode: Dict = self._uiconf['ro']

        vendor: str = pri_jnode.get('vendor') or 'zonechecker'
        if vendor == 'zonechecker':
            main_builder.setup_dec_streamer__bus_args([
                f'mg{main_builder.uimod_id}-zc{self._uimod_id}-scene'
            ])


RedlightUiConfProvider = _UiConfProvider
RailroadUiConfProvider = _UiConfProvider
