from typing import Optional

from edge import eventlog
from edge.support import fs


# noinspection PyClassHasNoInit
class PsuCtlUiconf:
    _CONF_PATH = '/etc/edge/setupstore/admin/actions/psu-ctl.json'

    @classmethod
    def get_endpoint(cls) -> Optional[str]:
        uiconf = fs.load_json3(cls._CONF_PATH, default=None)
        if uiconf is None:
            eventlog.log_w('fail: psu-ctl.conf not found')
            return

        conf_pri = uiconf.get('ro')
        if conf_pri is None:
            eventlog.log_w('fail: param psu-ctl.conf#/ro has invalid value')
            return

        com_port = conf_pri.get('com-port')
        if not com_port:
            eventlog.log_w('fail: param psu-ctl.conf#/ro/com-port has invalid value')
            return

        return com_port
