from typing import Dict, List, Self

DIR_UNKNOWN = 1
DIR_APPROACHING = 2
DIR_RECEDING = 3


class Fact:
    def __init__(self, args_jnode: Dict, args_store: str, arch_files: List[Dict], feed_files: Dict):
        self.jnode = args_jnode
        self.args_store = args_store
        self.arch_files = arch_files
        self.feed_files = feed_files

    @classmethod
    def unpack(cls, args_name: str, args_jnode: Dict) -> Self:
        """
        :param args_name:
        :param args_jnode:
            args.json#/

        :raise ValueError:
        """
        feed_files = {}
        arch_files = args_jnode['dist']
        args_blob_ref = args_name.split('-')[-1]

        for f in arch_files:
            altref = f.get('altref')
            if altref:
                # skip args.sign and args.crt
                if any(substring in altref for substring in ['.crt', '.sign']):
                    continue
                feed_files[altref.split('.')[0]] = f['ref']

        bs_chan = args_blob_ref.split('_')[0]
        return cls(args_jnode['args'], bs_chan, arch_files, feed_files)
