from typing import Optional, Dict, Self

from edge import eventlog
from renderer.services.types.tl import TlServiceConf


class JsonTlServiceArgs(TlServiceConf):
    def __init__(self, *args, **kwargs):
        super().__init__(*args, **kwargs)

    @classmethod
    def deserialize(cls, jnode: Optional[Dict]) -> Optional[Self]:
        """
        :raise JnodeError:
        """
        eventlog.log_i(f'jnode {jnode}')
        if jnode is None:
            return None

        if len(jnode) == 2:
            endpoint, tl_ident = jnode
            return cls(endpoint, tl_ident)

        else:
            eventlog.log_e("fail: tl args invalid")
            return None
