from typing import List

from speedcontrol.detectors.types.detector import DetectorUnitInfo


class DetectorsConf:
    def __init__(self,
                 base_confs: List[DetectorUnitInfo],
                 transit_confs: List[DetectorUnitInfo],
                 parking_confs: List[DetectorUnitInfo],
                 wrongway_confs: List[DetectorUnitInfo],
                 spotspeed_confs: List[DetectorUnitInfo],
                 spotspeed_waga_confs: List[DetectorUnitInfo],
                 redlight_confs: List[DetectorUnitInfo],
                 wanted_confs: List[DetectorUnitInfo],
                 sectionspeed_confs: List[DetectorUnitInfo],
                 redlight_railroad_confs: List[DetectorUnitInfo],
                 buslane_confs: List[DetectorUnitInfo],
                 seatbelt_confs: List[DetectorUnitInfo]):

        assert len(base_confs) == 1
        assert len(transit_confs) == 1

        self.base = base_confs
        self.transit = transit_confs
        self.parking = parking_confs
        self.wrong_way = wrongway_confs
        self.spot_speed = spotspeed_confs
        self.spot_speed_waga = spotspeed_waga_confs
        self.red_light = redlight_confs
        self.section_speed = sectionspeed_confs
        self.wanted = wanted_confs
        self.railroad_crossing = redlight_railroad_confs
        self.bus_lane = buslane_confs
        self.seatbelt = seatbelt_confs
