from typing import Dict, Optional

from edge.image.types.footer import ImFooterVars
from edge.services.types.about import IAboutService
from edge.services.types.tz import ITzService
from edge.types.geoposition import Geoposition
from edge.types.location import Location

from speedcontrol.events.vehicle import Vehicle


class BestImFooterVars(ImFooterVars):
    def __init__(self,
                 tz_service: ITzService,
                 about_service: IAboutService,
                 main_ts: int,
                 control_ts: Optional[int],
                 defvars: Optional[Dict],
                 location: Optional[Location],
                 geolocation: Optional[Geoposition],
                 plate_text: Optional[str],
                 vehicle: Vehicle) -> None:

        spotspeeds = vehicle.spotspeeds
        super().__init__(
            tz_service, about_service,
            main_ts,
            control_ts=control_ts,
            defvars=defvars,
            location=location,
            geolocation=geolocation,
            plate_text=plate_text,
            spot_speed=spotspeeds.ra_n,
            direction=vehicle.dir,
            spot_speed_ra_n=spotspeeds.ra_n,
            spot_speed_cam_2=spotspeeds.cam_2,
            spot_speed_cam_n=spotspeeds.cam_n,
            spot_speed_wim=spotspeeds.wim,
            spot_speed_main=spotspeeds.main,
            spot_speed_control=spotspeeds.control)
