from typing import Dict

from speedcontrol.detectors.base.types.stats import DetectorStats


def encode__detector_stats(name: str, stats: DetectorStats) -> Dict:
    return {
        'type': 'base',
        'name': name,
        'stat': {
            'load-measurements-image': {
                'count': [
                    stats.meas_im.total,
                    stats.meas_im.total - stats.meas_im.failure,
                    stats.meas_im.failure
                ],
                'arch': stats.meas_im.success_arch,
                'file': stats.meas_im.success_file
            },
            'load-overview-image': {
                'count': [
                    stats.over_im.total,
                    stats.over_im.total - stats.over_im.failure,
                    stats.over_im.failure
                ],
                'arch': stats.over_im.success_arch,
                'file': stats.over_im.success_file
            }
        }
    }
