from typing import Dict, List, Optional

from edge.image.types.types import EventMeasImBuilderConf
from edge.types.identity import Identity

from edge.support.mask import MaskConf
from edge.support.schedule import ScheduleConf
from speedcontrol.events.ticket import TicketInfo


class RuleLimits:
    def __init__(self, max_standing_time: int):
        self.max_standing_time = max_standing_time


class RuleConf:
    def __init__(self, name: str, enabled: bool, schedule: Optional[ScheduleConf], ticket: TicketInfo,
                 limits: RuleLimits, footer_defvars: Dict):
        self.name = name
        self.enabled = enabled
        self.schedule = schedule
        self.ticket = ticket
        self.limits = limits
        self.footer_defvars = footer_defvars


class DetectorConf:
    def __init__(self,
                 identity: Identity,
                 name: str,
                 store: str,
                 scene: MaskConf,
                 rules: List[RuleConf],
                 init_imbuilder: EventMeasImBuilderConf,
                 fini_imbuilder: EventMeasImBuilderConf,
                 range_tout: int,
                 lost_tout: int):

        self.identity = identity
        self.name = name
        self.store = store
        self.scene = scene
        self.rules = rules
        self.init_imbuilder = init_imbuilder
        self.fini_imbuilder = fini_imbuilder
        self.log_range_tout = range_tout * 1e6
        self.log_lost_tout = lost_tout * 1e6
