from typing import Dict, List, Optional

from edge.image.types.types import EventMeasImBuilderConf

from speedcontrol.detectors.types.conf import VideoConf
from speedcontrol.events.ticket import TicketInfo
from edge.support.mask import MaskConf
from edge.types.identity import Identity


class RuleConf:
    def __init__(self, name: str, ticket: TicketInfo, footer_defvars: Dict):
        self.name = name
        self.ticket = ticket
        self.footer_defvars = footer_defvars


class DetectorConf:
    def __init__(self,
                 identity: Identity,
                 name: str,
                 store: str,
                 scene: MaskConf,
                 rules: List[RuleConf],
                 imbuilder: EventMeasImBuilderConf,
                 video: Optional[VideoConf],
                 direction: str):

        self.identity = identity
        self.name = name
        self.store = store
        self.scene = scene
        self.rules = rules
        self.imbuilder = imbuilder
        self.video = video
        self.dir_r = direction == 'receding'
