from typing import Self

from edge.services.types.about import IAboutService
from edge.services.types.tz import ITzService
from edge.support.service import ServicePack
from speedcontrol.services.types.tl import ITlService
from edge.services.types.vs import IVsService


class RuleDeps:
    def __init__(self,
                 tz_service: ITzService,
                 vs_service: IVsService,
                 about_service: IAboutService,
                 tl_service: ITlService):

        self.tz = tz_service
        self.vs = vs_service
        self.about = about_service
        self.tl = tl_service

    @classmethod
    def create(cls, services: ServicePack) -> Self:
        return cls(
            services.get(ITzService),
            services.get(IVsService),
            services.get(IAboutService),
            services.get(ITlService))


class DetectorDeps(RuleDeps):
    pass
