from typing import Dict, List

from edge.image.types.types import EventMeasImBuilderConf

from speedcontrol.events.ticket import TicketInfo
from edge.types.identity import Identity


class SeatConf:
    def __init__(self, analyze: bool, blur: bool, min_weight: int):
        self.analyze = analyze
        self.blur_if_no_violation = blur
        self.min_weight = min_weight


class DetectorConf:
    def __init__(self,
                 identity: Identity,
                 name: str,
                 store: str,
                 seats: List[SeatConf],
                 ticket: TicketInfo,
                 imbuilder: EventMeasImBuilderConf,
                 def_footer_mapping: Dict):

        self.identity = identity
        self.name = name
        self.store = store

        self.seats = seats
        self.ticket = ticket
        self.imbuilder = imbuilder
        self.def_footer_mapping = def_footer_mapping
