from typing import Dict, Optional

from edge.image.types.footer import ImFooterVars
from edge.services.types.about import IAboutService
from edge.services.types.tz import ITzService
from edge.types.dir import Dir
from edge.types.origin import Origin
from speedcontrol.events.spotspeed import SpotSpeeds


class EvidenceImFooterVars(ImFooterVars):
    def __init__(self,
                 tz_service: ITzService,
                 about_service: IAboutService,
                 main_ts: int,
                 defvars: Optional[Dict],
                 origin: Origin,
                 spotspeeds: SpotSpeeds,
                 plate_text: str,
                 direction: Dir,
                 speed_limit: int,
                 ra_overspeed: int,
                 main_overspeed: int):

        super().__init__(
            tz_service,
            about_service,
            main_ts,
            defvars=defvars,
            location=origin.location,
            geolocation=origin.geolocation,
            plate_text=plate_text,
            spot_speed=spotspeeds.main.measured,
            spot_speed_main=spotspeeds.main,
            spot_speed_control=spotspeeds.control,
            direction=direction,
            spot_speed_cam_2=spotspeeds.control.measured,
            spot_speed_ra_n=spotspeeds.main.measured,
            speed_limit=speed_limit,
            spot_overspeed_ra_n=ra_overspeed,
            spot_overspeed_main=main_overspeed,
            spot_speed_cam_n=spotspeeds.cam_n)
