from typing import Optional, Tuple

from edge.support.schedule import ScheduleConf
from speedcontrol.events.ticket import TicketInfo


class BaseRuleConf:
    def __init__(self, name: str, enabled: bool, ticket: TicketInfo, schedule: Optional[ScheduleConf] = None):
        self.name = name
        self.enabled = enabled
        self.ticket = ticket
        self.schedule = schedule


class VideoConf:
    def __init__(self,
                 max_w: int = 32752,
                 max_h: int = 32752,
                 video_format: str = 'h264-mp4',
                 quality: int = 500,
                 pre_record: int = 5000,
                 post_record: int = 5000):

        self.max_w = max_w
        self.max_h = max_h
        self.pre_record = pre_record
        self.post_record = post_record

        self.quality = quality
        self.format = video_format

    @property
    def max_wh(self) -> Tuple[int, int]:
        return self.max_w, self.max_h
