from typing import List, Optional

from speedcontrol.events.ticket import TicketInfo
from edge.types.identity import Identity


class RuleLimits:
    def __init__(self, plate_dist: int, list_owner: Optional[str], list_name: Optional[str]):
        self.plate_dist = plate_dist
        self.list_owner = list_owner
        self.list_name = list_name


class RuleConf:
    def __init__(self, name: str, enabled: bool, ticket: TicketInfo, limits: RuleLimits):
        self.name = name
        self.enabled = enabled
        self.ticket = ticket
        self.limits = limits


class DetectorConf:
    def __init__(self, identity: Identity, name: str, store: str, rules: List[RuleConf]):
        self.name = name
        self.store = store
        self.identity = identity
        self.rules = rules
