from typing import Self

from edge.services.db_wanted import DbWantedService
from edge.services.types.about import IAboutService
from edge.support.service import ServicePack


class RuleDeps:
    def __init__(self, about_service: IAboutService, wanted_service: DbWantedService):
        self.about = about_service
        self.wanted = wanted_service

    @classmethod
    def create(cls, services: ServicePack) -> Self:
        return cls(
            services.get(IAboutService),
            services.get(DbWantedService))


class DetectorDeps(RuleDeps):
    pass
