from typing import Dict, Any, Final, Optional

from speedcontrol.events.schedule import ScheduleInfo
from speedcontrol.events.ticket import TicketInfo


class RuleInfo:
    def __init__(self,
                 name: str,
                 schedule: Optional[ScheduleInfo],
                 ticket: TicketInfo,
                 limits: Dict[str, Any] | None = None) -> None:

        self.name: Final[str] = name
        self.schedule: Final[ScheduleInfo | None] = schedule
        self.ticket: Final[TicketInfo] = ticket
        self.limits: Final[Dict[str, Any] | None] = limits


class DetectorInfo:
    def __init__(self, name: str, rule: RuleInfo):
        self.name: Final[str] = name
        self.rule: Final[RuleInfo] = rule
