from typing import Optional, List, Dict

from edge.services.types.tz import ITzService
from edge.types.blob import MemBlob
from edge.types.origin import Origin
from speedcontrol.events.evidence import BaseEvidence


class TransitEvidence(BaseEvidence):
    def __init__(self, origin: Origin, ts: int, control_ts: Optional[int] = None):
        super().__init__(BaseEvidence.EVENT_TYPE__TRANSIT, origin, ts, control_ts=control_ts)

    def get_blobs(self) -> List[MemBlob]:
        return []

    def serialize(self, tz_service: ITzService) -> Dict:
        jnode = BaseEvidence.serialize(self, tz_service)
        return jnode
