from typing import Dict

from edge.types.blob import TBlob, BsChanRef, BlobProfileToBsChanMap
from edge.services.types.service import IService
from edge.types.identity import Identity

BsSender = Identity
BsSenderToChanMap = Dict[BsSender, BsChanRef | BlobProfileToBsChanMap]


class BsServiceConf:
    def __init__(self, module_id: int, log_level: str):
        self.module_id = module_id
        self.log_level = log_level


class IBsService(IService):
    def setup(self, sender_to_chan_map: BsSenderToChanMap) -> None:
        raise NotImplementedError

    def get_size(self, sender: Identity, blob_id: str, profile: str) -> int:
        raise NotImplementedError

    def save(self, sender: Identity, blob: TBlob) -> None:
        """
        :raise bs.BsError:
        """
        raise NotImplementedError
