from typing import Dict, List

from edge.services.types.service import IService
from edge.support.db import DbArgs


class DbServiceConf:
    def __init__(self, origin_id: int, db_args: DbArgs):
        self.origin_id = origin_id
        self.db_args = db_args


class IDbService(IService):
    def set_log(self, detector_ref: int, plate_text: str, log_min_ts: int, log_max_ts: int, log_jnode: Dict) -> None:
        raise NotImplementedError

    def get_log(self, detector_ref: int, plate_text: str, plate_dist: int = 0) -> List[Dict]:
        raise NotImplementedError

    def del_log(self, detector_ref: int, plate_text: str) -> bool:
        raise NotImplementedError

    def clear_log(self, detector_ref: int, max_ts: int) -> bool:
        raise NotImplementedError

    def get_last_parking(self, plate_text: str, origin_uuid: str, min_search_time: str) -> None:
        raise NotImplementedError
