from typing import List, Optional

from edge.services.types.service import IService
from speedcontrol.events.event import Event


class EventQueueConf:
    def __init__(self, endpoint: str, min_file_count: int, max_file_count: int):
        self.endpoint = endpoint
        self.min_file_count = min_file_count
        self.max_file_count = max_file_count


class EventServiceConf:
    def __init__(self,
                 require_plate: bool,
                 json_queue_list: List[EventQueueConf],
                 ua_json_required: bool,
                 local_arch_base_dir: Optional[str]):

        self.require_plate = require_plate
        self.json_queue_list = json_queue_list
        self.ua_json_required = ua_json_required

        self.local_arch_enabled = local_arch_base_dir is not None
        self.local_arch_base_dir = local_arch_base_dir


class IEventService(IService):
    def emit(self, event: Event) -> bool:
        raise NotImplementedError()
