from typing import Dict

from edge import eventlog
from edge.support.db import DbArgs
from edge.types.exceptions import JnodeError
from speedcontrol.services.types.db import DbServiceConf


def decode__db_service_conf(origin_id: int, jnode: Dict) -> DbServiceConf:
    """
    :raise JnodeError:
    """
    db_jnode = jnode.get('db')
    if not db_jnode:
        eventlog.log_e('fail: param #/db is absent')
        raise JnodeError

    db_args = DbArgs.deserialize(db_jnode)
    return DbServiceConf(origin_id, db_args)
