from typing import Optional, Dict, List

from edge.services.types.service import IService
from edge.types.timespan import TimeSpan


class LeddarServiceConf:
    def __init__(self, endpoint: str, ref: str):
        self.endpoint = endpoint
        self.ref = ref


class ILeddarService(IService):
    def ref(self) -> Optional[str]:
        return None

    def update(self, react_jnode: Dict) -> None:
        raise NotImplementedError

    def check(self, min_ts: int, max_ts: int) -> List[TimeSpan]:
        raise NotImplementedError
