from typing import Callable

from edge.types.image import ImRgba
from edge.types.shape.rect import RectI
from edge.services.types.service import IService

from speedcontrol.trackset.vrp import TrackVrp


class RaasServiceConf:
    def __init__(self, raas_host: str, raas_port: str, raas_user: str, raas_pass: str):
        self.raas_host = raas_host
        self.raas_port = raas_port
        self.raas_user = raas_user
        self.raas_pass = raas_pass


class IRaasService(IService):
    def analyze(self, image_rgba: ImRgba, image_roi: RectI, handler: Callable[[TrackVrp | None], None]) -> None:
        raise NotImplementedError()
