from typing import List

from edge.services.types.service import IService
from edge.support import bs
from edge.types.stats import IStatsProvider


class StatsServiceConf:
    def __init__(self, stat_filepath: str, stat_tout_sec: int):
        self.stat_filepath = stat_filepath
        self.stat_tout_sec = stat_tout_sec


class IEventCounters:
    def inc_fact(self) -> None:
        raise NotImplementedError

    @property
    def fact_count(self) -> int:
        raise NotImplementedError


class IStatService(IService):
    @property
    def event(self) -> IEventCounters:
        raise NotImplementedError

    @property
    def bs(self) -> bs.IBsCounters:
        raise NotImplementedError

    def add_providers(self, providers: List[IStatsProvider]) -> None:
        raise NotImplementedError
