from typing import List, Tuple, Optional

from edge.services.types.service import IService
from edge.types.timespan import TimeSpan


class TlServiceConf:
    def __init__(self, endpoint: str, tl_ident: int, red_only: bool = False):
        self.endpoint = endpoint
        self.tl_ident = tl_ident
        self.red_only = red_only


class ITlService(IService):
    def check(self, min_ts: int, max_ts: int) -> List[TimeSpan]:
        raise NotImplementedError

    def get_times(self, ts: int) -> Tuple[Optional[int], Optional[int], Optional[int], Optional[int]]:
        """
        :param ts:
            value in usec

        :returns:
            (green-amber-time, red-time, red-amber-time, halt-time)
            Values in usec
        """
        raise NotImplementedError
