from datetime import time
from typing import Final, List

from edge.services.types.service import IService
from edge.types.image import ImRgba

from speedcontrol.events.event import BaseEvent
from speedcontrol.trackset.trackset import Trackset


class TrainerServiceConf:
    LR_ANY = 'any'
    LR_PRESRNT = 'present'
    LR_ABSENT = 'absent'

    def __init__(self,
                 root_dir: str,
                 lanes: List[str],
                 min_time: time,
                 max_time: time,
                 min_df: float,
                 lr: str = LR_ANY):

        self.root_dir: Final[str] = root_dir
        self.min_time: Final[time] = min_time
        self.max_time: Final[time] = max_time
        self.lanes: Final[List[str]] = lanes
        self.min_df: Final[float] = min_df
        self.lr: Final[str] = lr


class ITrainerService(IService):
    def collect(self, base_event: BaseEvent, trackset: Trackset, scene_rgba: ImRgba) -> None:
        raise NotImplementedError()
