from typing import Dict

from edge.types.imageref import ImageRef
from speedcontrol.trackset.wa import WaTrack


def decode__wa_track(jnode: Dict) -> WaTrack:
    """
    :param jnode:
        TrTrack#/Wa
    """
    weight = jnode['weight']
    height = jnode['size-h']
    width = jnode['size-w']
    length = jnode['size-l']
    lane = jnode['lane']
    event_id = jnode['event-id']
    event_ts = jnode['event-ts']
    duration = jnode['event-dur']

    provider = jnode['vrp-provider']
    vrp_front = jnode['vrp-front']
    vrp_back = jnode['vrp-back']

    vrp_front_w = jnode.get('vrp-front-w')
    vrp_back_w = jnode.get('vrp-back-w')

    speed = jnode['speed']
    axle_count = jnode['axle-count']
    axle_layout = jnode['axle-layout']

    vehicle_class = jnode['class']
    road_temperature = jnode['road-temperature']

    overview_ref = ImageRef(jnode.get('im-overview-ts'), codec='JPEG', url=jnode.get('im-overview'))
    return WaTrack(weight, height, width, length, lane, event_id, event_ts, duration, provider, vrp_front, vrp_back,
                   vrp_front_w, vrp_back_w, speed, axle_count, axle_layout, vehicle_class,
                   road_temperature, overview_ref)
