from typing import Final, List, Optional

from speedcontrol.trackset.vrp import TrackVrp


class RaasSceneItem:
    def __init__(self, variants: List[TrackVrp]):
        self.variants: Final[List[TrackVrp]] = variants


class RaasScene:
    def __init__(self, items: List[RaasSceneItem]):
        self.items: Final[List[RaasSceneItem]] = items

    @property
    def best_vrp_variant(self) -> Optional[TrackVrp]:
        for item in self.items:
            max_conf_variant = max(item.variants, key=lambda v: v.text_conf)
            return max_conf_variant
