from typing import Final, Self

from edge.types.shape.quad import QuadI


class TrackVrpType:
    """
    The type of Vehicle Registration Plate
    """
    def __init__(self, country_a2: str, template_ref: int):
        self.country_a2: Final[str] = country_a2
        self.template_ref: Final[int] = template_ref


class TrackVrp:
    def __init__(self, vrp_type: TrackVrpType, text_quad: QuadI, text_ucode: str, text_conf: int) -> None:
        self.type: Final[TrackVrpType] = vrp_type

        self.text_quad: Final[QuadI] = text_quad
        self.text_ucode: Final[str] = text_ucode
        self.text_conf: Final[int] = text_conf

    @classmethod
    def from_proto(cls, proto: Self, text_quad: QuadI) -> Self:
        return TrackVrp(proto.type, text_quad, proto.text_ucode, proto.text_conf)
