from os.path import isabs
from typing import Dict, Self


class StatsServiceConf:
    def __init__(self, stat_filepath: str, stat_tout_sec: int):
        self.stat_filepath = stat_filepath
        self.stat_tout_sec = stat_tout_sec

    @classmethod
    def deserialize(cls, monitoring_jnode: Dict) -> Self:
        stat_filepath = monitoring_jnode.get('StatFile')
        if not (str == type(stat_filepath) and len(stat_filepath) < 64 and isabs(stat_filepath)):
            raise ValueError('main.conf#/Monitoring/StatFile')

        raw_stat_tout_sec = monitoring_jnode.get('StatTout')
        if not (int == type(raw_stat_tout_sec) and 0 <= raw_stat_tout_sec <= 255):
            raise ValueError('main.conf#/Monitoring/StatTout')

        args = cls(stat_filepath, raw_stat_tout_sec)
        return args
