from typing import Set, Self

from edge.types.imageref import ImageRef
from tracker.types.lrra import LrRaScene


class SceneEmitterConf:
    def __init__(self, event_dirs: Set[str], skip_rate: int):
        self.event_dirs = event_dirs
        self.skip_rate = skip_rate

    @classmethod
    def deserialize(cls, event_dirs: Set[str], skip_rate: int) -> Self:
        return cls(event_dirs, skip_rate)


class ISceneEmitter:
    def consume_scene(self, im_ref: ImageRef, lrra_scene: LrRaScene) -> None:
        raise NotImplementedError()
