from typing import Dict, Self

from edge.services.types.service import IService


class SceneProviderConf:
    def __init__(self, mc_dir: str, mg_dir: str, lr_dir: str, ra_dir: str, tout_msec: str):
        self.mc_dir = mc_dir
        self.mg_dir = mg_dir
        self.lr_dir = lr_dir
        self.ra_dir = ra_dir
        self.tout_msec = tout_msec

    @classmethod
    def deserialize(cls, scene_react_jnode: Dict) -> Self:
        mc_dir = scene_react_jnode.get('McDir', '')
        mg_dir = scene_react_jnode.get('MgDir', '')
        lr_dir = scene_react_jnode.get('LrDir', '')
        ra_dir = scene_react_jnode.get('RaDir', '')
        tout = scene_react_jnode['Tout']

        if not mc_dir and not mg_dir:
            raise ValueError('At least one of mc_dir or mg_dir should be defined')

        if not lr_dir:
            raise ValueError('The lr_dir should be defined')

        args = cls(mc_dir, mg_dir, lr_dir, ra_dir, tout)
        return args


class ISceneProvider(IService):
    def set_handler(self, handler):
        raise NotImplementedError
