from abc import ABCMeta, abstractmethod
from typing import Callable, List

from edge.services.types.service import IService
from tracker.types.ra import RaTrack, RaSceneItem


class IRaTrackBuilder(IService, metaclass=ABCMeta):
    @abstractmethod
    def set_tout_handler(self, handler: Callable[[RaTrack], None]) -> None:
        pass

    @abstractmethod
    def add_scene(self, items: List[RaSceneItem]) -> None:
        pass

    @abstractmethod
    def get_track(self, ra_oid: int) -> None:
        pass

    @abstractmethod
    def del_track(self, ra_oid: int) -> None:
        pass
